function FIXEDP_adm(action)

global scale NewXLim NewYLim L_X M_X R_X

switch action

case 'x'
   h=findobj(gcbf,'Tag','x');
   x=get(h,'String');
   x=eval(x);
   h=findobj(gcbf,'Tag','my_fcn');
   g=get(h,'String');
   g=eval(g);
   set(findobj(gcbf,'Tag','g(x)'),'String',num2str(g))
   FIXEDP_adm('update')
   
   
case 'update'
   dx=diff(get(gca,'XLim'));
   hx=findobj(gcbf,'Tag','x');
   x=eval(get(hx,'String'));
   hgx=findobj(gcbf,'Tag','g(x)');
   gx=eval(get(hgx,'String'));
   h=findobj(gcbf,'Tag','curr_iteration');
   set(h,'XData',[x x 0],'YData',[0 gx gx])
   hx=findobj(gcbf,'Tag','x-text');
   set(hx,'Position',[x-.05/dx -.1/dx])
   hgx=findobj(gcbf,'Tag','gx-text');
   set(hgx,'Position',[-.4/dx gx])
   hgx2=findobj(gcbf,'Tag','gx2-text');
   set(hgx2,'Visible','off')
   drawnow
   pause(1)
   set(h,'XData',[x x 0 gx gx],'YData',[0 gx gx gx 0])
   hgx2=findobj(gcbf,'Tag','gx2-text');
   set(hgx2,'Position',[gx-.15/dx -.1/dx],'Visible','on')
   drawnow
   pause(1)
%   format long
%  L_X{size(L_X,1)+1,1}=num2str(l_x)
%  M_X{size(M_X,1)+1,1}=num2str((l_x+r_x)/2)
%  R_X{size(R_X,1)+1,1}=num2str(r_x)
%   format short  
   
   
case 'iterate'
   h=findobj(gcbf,'Tag','g(x)');
   new_x=get(h,'String');
   h=findobj(gcbf,'Tag','x');
   set(h,'String',new_x)
   FIXEDP_adm('x')
   
   
case 'nits'
   h=findobj(gcbf,'Tag','nits');
   nits=get(h,'String');
   nits=eval(nits);
   for i=1:nits
     FIXEDP_adm('iterate')
   end
   
   
case 'tol'
   h=findobj(gcbf,'Tag','tol');
   tol=get(h,'String');
   tol=eval(tol);
   dx=1;
   hx=findobj(gcbf,'Tag','x');
   hgx=findobj(gcbf,'Tag','g(x)');
   while dx>tol
      FIXEDP_adm('iterate')
      x=eval(get(hx,'String'));
      gx=eval(get(hgx,'String'));
      dx=abs(gx-x);
   end
   
   
case 'zoom in'
  
  scale=.5;
  set(gcf,'WindowButtonDownFcn','FIXEDP_adm(''zoom'')')


case 'zoom out'
  
  scale=2;
  set(gcf,'WindowButtonDownFcn','FIXEDP_adm(''zoom'')')
  
  
case 'zoom'
   
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   FIXEDP_adm('plot_fcn')      
   
   
case 'choose_fcn'

  value=get(findobj(gcbf,'Tag','g_gallery'),'Value');
  string=get(findobj(gcbf,'Tag','g_gallery'),'String');
  f=string{value};

  set(findobj(gcbf,'Tag','my_fcn'),'String',f)
  FIXEDP_adm('plot_fcn')


case 'plot_fcn'

  delete(findobj(gcbf,'Tag','y=x'))
  delete(findobj(gcbf,'Tag','f_graph'))
  title('')

  f=get(findobj(gcbf,'Tag','my_fcn'),'String');
  if isempty(f)
    disp('no graph to plot')
  else
    f=get(findobj(gcbf,'Tag','my_fcn'),'String');
    XLim=get(gca,'XLim');
    YLim=get(gca,'YLim');
    dX=diff(XLim);
    x=XLim(1):dX/100:XLim(2);
    y=eval(f);
    line(x,x,'Color','r','Tag','y=x')
    line(x,eval(f),'Color','r','Tag','f_graph')
    title(['y = x   and   y = ' f])
    axis([x(1) x(length(x)) min(y)-.5 max(y)+.5]);
    set(findobj('Tag','x_axis'),'XData',XLim)
    set(findobj('tag','y_axis'),'Ydata',YLim)
    set(gca,'XLim',XLim,'YLim',YLim)
  end
   

end




