function fig = FE()
% This is the machine-generated representation of a Handle Graphics object
% and its children.  Note that handle values may change when these objects
% are re-created. This may cause problems with any callbacks written to
% depend on the value of the handle at the time the object was saved.
% This problem is solved by saving the output as a FIG-file.
%
% To reopen this object, just type the name of the M-file at the MATLAB
% prompt. The M-file and its associated MAT-file must be on your path.
% 
% NOTE: certain newer features in MATLAB may not have been saved in this
% M-file due to limitations of this format, which has been superseded by
% FIG-files.  Figures which have been annotated using the plot editor tools
% are incompatible with the M-file/MAT-file format, and should be saved as
% FIG-files.

load FE

h0 = figure('Color',[0.8 0.8 0.8], ...
	'Colormap',mat0, ...
	'FileName','/users/math/kenneth/matlab/guis/FE.m', ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
	'Position',[658 97 444 604], ...
	'Renderer','zbuffer', ...
	'RendererMode','manual', ...
	'Tag','Fig1', ...
	'ToolBar','none', ...
	'UserData',[174.0032958984375 125.0029296875], ...
	'WindowButtonDownFcn','FEadm(''mark bdry'')');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0 1 1], ...
	'FontSize',25, ...
	'ListboxTop',0, ...
	'Position',mat1, ...
	'String','FE lab', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.8990986019131714 0.1595345345345345 0.03909124356144224], ...
	'String','x', ...
	'Style','edit', ...
	'Tag','f', ...
	'TooltipString','Data in  div (- a grad u) = f ');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.7019609999999999 0.7019609999999999 0.7019609999999999], ...
	'Callback','FEadm(''cont+flux'')', ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.3909124356144223 0.1595345345345345 0.03909124356144224], ...
	'String','contours', ...
	'Style','checkbox', ...
	'Tag','contours', ...
	'TooltipString','Plot level curves of  u(x,y)');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.7019609999999999 0.7019609999999999 0.7019609999999999], ...
	'Callback','FEadm(''cont+flux'')', ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.3420483811626195 0.1595345345345345 0.03909124356144224], ...
	'String','flux', ...
	'Style','checkbox', ...
	'Tag','gradients', ...
	'TooltipString','Plot flux  a grad u');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','FEadm(''new bdry segm'')', ...
	'ListboxTop',0, ...
	'Position',[0.2393018018018018 0.01954562178072112 0.1595345345345345 0.03909124356144224], ...
	'String','inner bdry', ...
	'Tag','Pushbutton1', ...
	'TooltipString','point-click clockwise');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'Callback','FEadm(''refine'')', ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.01954562178072112 0.1595345345345345 0.03909124356144224], ...
	'String','refine mesh', ...
	'Tag','Pushbutton2', ...
	'TooltipString','Refine mesh');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'HandleVisibility','off', ...
	'ListboxTop',0, ...
	'Position',[0.002252252252252252 0.001655629139072848 0.2927927927927928 0.03311258278145696], ...
	'Style','text', ...
	'Tag','StaticText2', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'HandleVisibility','off', ...
	'ListboxTop',0, ...
	'Position',[0.002252252252252252 0.001655629139072848 0.2927927927927928 0.03311258278145696], ...
	'Style','text', ...
	'Tag','StaticText3', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'Callback','FEadm(''mesh'')', ...
	'ListboxTop',0, ...
	'Position',[0.6115490490490491 0.01954562178072112 0.1595345345345345 0.03909124356144224], ...
	'String','mesh', ...
	'Tag','Pushbutton3', ...
	'TooltipString','Define domain and computational mesh');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'Callback','set(gcbf,''WindowButtonDownFcn'',''FEadm(''''modify'''')'')', ...
	'ListboxTop',0, ...
	'Position',[0.4254254254254254 0.01954562178072112 0.1595345345345345 0.03909124356144224], ...
	'String','modify', ...
	'Tag','Pushbutton4', ...
	'TooltipString','Point & drag modify boundary curve');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.8404617365710081 0.1595345345345345 0.03909124356144224], ...
	'String','1', ...
	'Style','edit', ...
	'Tag','a', ...
	'TooltipString','Data in  div (- a grad u) = f ');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'Callback','FEadm(''new domain'')', ...
	'ListboxTop',0, ...
	'Position',[0.05180180180180179 0.01821192052980132 0.1599099099099099 0.03973509933774834], ...
	'String','new domain', ...
	'Tag','Pushbutton8', ...
	'TooltipString','Point-click and/or give param bdry segments counter-clockwise');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 0], ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[0.3456581581581581 0.5277317880794702 0.3988363363363363 0.03909124356144224], ...
	'String','integral = -2.4451', ...
	'Style','text', ...
	'Tag','integral', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 0], ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[0.3456581581581581 0.1172737306843267 0.3988363363363363 0.03909124356144224], ...
	'String','define boudary curve', ...
	'Style','text', ...
	'Tag','curveint', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[0.73119994994995 0.4515038631346578 0.0611549049049049 0.03518211920529801], ...
	'String','y =', ...
	'Style','text', ...
	'Tag','y=', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.7019609999999999 0.7019609999999999 0.7019609999999999], ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[0.73119994994995 0.4905951066961 0.0611549049049049 0.03518211920529801], ...
	'String','x =', ...
	'Style','text', ...
	'Tag','x=', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.4495493009565857 0.1595345345345345 0.03909124356144224], ...
	'String','sin(2*pi*s)', ...
	'Style','edit', ...
	'Tag','y', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.4886405445180279 0.1595345345345345 0.03909124356144224], ...
	'String','cos(2*pi*s)', ...
	'Style','edit', ...
	'Tag','x', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'Callback','FEadm(''ok'')', ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[0.6115490490490491 0.4690949227373068 0.06647272272272273 0.03909124356144224], ...
	'String','ok', ...
	'Tag','ok', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HandleVisibility','off', ...
	'ListboxTop',0, ...
	'Position',[0.002252252252252252 0.001655629139072848 0.2927927927927928 0.03311258278145696], ...
	'String','Az:  -38 El:   30', ...
	'Style','text', ...
	'Tag','StaticText4', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'HandleVisibility','off', ...
	'ListboxTop',0, ...
	'Position',[0.002252252252252252 0.001655629139072848 0.2927927927927928 0.03311258278145696], ...
	'Style','text', ...
	'Tag','StaticText5', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.7019609999999999 0.7019609999999999 0.7019609999999999], ...
	'ListboxTop',0, ...
	'Position',[0.7444944944944945 0.7818248712288447 0.04786036036036036 0.0332275570272259], ...
	'String','k =', ...
	'Style','text', ...
	'Tag','StaticText6');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.7019609999999999 0.7019609999999999 0.7019609999999999], ...
	'ListboxTop',0, ...
	'Position',[0.7444944944944945 0.7231880058866813 0.04786036036036036 0.0332275570272259], ...
	'String','g =', ...
	'Style','text', ...
	'Tag','StaticText7');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.7818248712288447 0.1595345345345345 0.03909124356144224], ...
	'String','10000', ...
	'Style','edit', ...
	'Tag','k', ...
	'TooltipString','Data in b.c.   a n grad u = k (g - u ) ');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.7231880058866813 0.1595345345345345 0.03909124356144224], ...
	'String','0', ...
	'Style','edit', ...
	'Tag','g', ...
	'TooltipString','Data in b.c.   a n grad u = k (g - u) ');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','FEadm(''solve'')', ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.5863686534216335 0.1595345345345345 0.03909124356144224], ...
	'String','solve', ...
	'Tag','solve', ...
	'TooltipString','Solve for  u(x,y)  with given data');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'Callback','FEadm(''residual'')', ...
	'ListboxTop',0, ...
	'Position',mat2, ...
	'String','residual', ...
	'Tag','residual', ...
	'TooltipString','Compute residual   f - div (a grad u)');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.7019609999999999 0.7019609999999999 0.7019609999999999], ...
	'ListboxTop',0, ...
	'Position',[0.7444944944944945 0.8404617365710081 0.04786036036036036 0.0332275570272259], ...
	'String','a =', ...
	'Style','text', ...
	'Tag','StaticText6');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.7019609999999999 0.7019609999999999 0.7019609999999999], ...
	'ListboxTop',0, ...
	'Position',[0.7444944944944945 0.8990986019131714 0.04786036036036036 0.0332275570272259], ...
	'String','f =', ...
	'Style','text', ...
	'Tag','StaticText6');
h1 = axes('Parent',h0, ...
	'CameraUpVector',[0 1 0], ...
	'CameraUpVectorMode','manual', ...
	'Color',[1 1 1], ...
	'ColorOrder',mat3, ...
	'DrawMode','fast', ...
	'HandleVisibility','off', ...
	'Tag','rotaObj', ...
	'UserData',mat4, ...
	'Visible','off', ...
	'XColor',[0 0 0], ...
	'YColor',[0 0 0], ...
	'ZColor',[0 0 0]);
h2 = line('Parent',h1, ...
	'Clipping','off', ...
	'Color',[0 0 1], ...
	'EraseMode','xor', ...
	'HandleVisibility','off', ...
	'Tag','rotaObjLine1', ...
	'Visible','off', ...
	'XData',mat5, ...
	'YData',mat6, ...
	'ZData',mat7);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4985422740524781 -0.04065040650406515 9.160254037844386], ...
	'Tag','rotaObjText4', ...
	'VerticalAlignment','cap', ...
	'Visible','off');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[-0.06997084548104958 0.4979674796747967 9.160254037844386], ...
	'Rotation',90, ...
	'Tag','rotaObjText3', ...
	'VerticalAlignment','baseline', ...
	'Visible','off');
set(get(h2,'Parent'),'YLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Position',[-0.1720116618075802 1.089430894308943 9.160254037844386], ...
	'Tag','rotaObjText2', ...
	'Visible','off');
set(get(h2,'Parent'),'ZLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',mat8, ...
	'Tag','rotaObjText1', ...
	'VerticalAlignment','bottom', ...
	'Visible','off');
set(get(h2,'Parent'),'Title',h2);
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'HandleVisibility','off', ...
	'ListboxTop',0, ...
	'Position',[0.002252252252252252 0.001655629139072848 0.2927927927927928 0.03311258278145696], ...
	'Style','text', ...
	'Tag','StaticText8', ...
	'Visible','off');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','FEadm(''apply'')', ...
	'ListboxTop',0, ...
	'Position',[0.7976726726726726 0.664551140544518 0.1595345345345345 0.03909124356144224], ...
	'String','apply to ..', ...
	'Tag','Pushbutton9', ...
	'TooltipString','Point-click at bdry segment');
h1 = axes('Parent',h0, ...
	'CameraUpVector',[0 1 0], ...
	'CameraUpVectorMode','manual', ...
	'Color',[1 1 1], ...
	'ColorOrder',mat9, ...
	'Position',[0.1 0.1 0.6 0.35], ...
	'Tag','Axes2', ...
	'XColor',[0 0 0], ...
	'XLim',[-0.1 1.1], ...
	'XLimMode','manual', ...
	'YColor',[0 0 0], ...
	'YLim',[-0.1 1.1], ...
	'YLimMode','manual', ...
	'ZColor',[0 0 0]);
h2 = patch('Parent',h1, ...
	'EdgeColor','none', ...
	'FaceColor','interp', ...
	'Faces',mat10, ...
	'FaceVertexCData',mat11, ...
	'NormalMode','manual', ...
	'Tag','Axes2Patch1', ...
	'VertexNormals',mat12, ...
	'Vertices',mat13);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4954887218045112 1.128436018957346 17.32050807568877], ...
	'String','domain', ...
	'Tag','Axes2Text4', ...
	'VerticalAlignment','bottom');
set(get(h2,'Parent'),'Title',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4954887218045112 -0.2137440758293837 17.32050807568877], ...
	'String','x', ...
	'Tag','Axes2Text3', ...
	'VerticalAlignment','cap');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[-0.2082706766917295 0.4914691943127966 17.32050807568877], ...
	'Rotation',90, ...
	'String','y', ...
	'Tag','Axes2Text2', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'YLabel',h2);
h2 = line('Parent',h1, ...
	'Color',[0 0 1], ...
	'Tag','Axes2Line2', ...
	'XData',mat14, ...
	'YData',mat15);
h2 = line('Parent',h1, ...
	'Color',[1 0 0], ...
	'Tag','Axes2Line1', ...
	'XData',mat16, ...
	'YData',mat17);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[-0.006666666666666793 0.9488888888888886], ...
	'YData',[0.05600000000000013 0.04400000000000026]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[0.9488888888888886 0.9933333333333333], ...
	'YData',[0.04400000000000026 0.8840000000000003]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[0.9933333333333333 0.4866666666666666], ...
	'YData',[0.8840000000000003 0.9740000000000001]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[0.4866666666666666 0.4377777777777776], ...
	'YData',[0.9740000000000001 0.6380000000000001]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',mat18, ...
	'YData',[0.6380000000000001 0.9140000000000003]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',mat19, ...
	'YData',[0.9140000000000003 0.05600000000000013]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[0.5888888888888887 0.5888888888888887], ...
	'YData',[0.2660000000000003 0.5480000000000004]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[0.5888888888888887 0.8066666666666666], ...
	'YData',[0.5480000000000004 0.5300000000000004]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[0.8066666666666666 0.771111111111111], ...
	'YData',[0.5300000000000004 0.2900000000000001]);
h2 = line('Parent',h1, ...
	'Color',[0 1 0], ...
	'Tag','curve', ...
	'Visible','off', ...
	'XData',[0.771111111111111 0.5888888888888887], ...
	'YData',[0.2900000000000001 0.2660000000000003]);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Position',[-0.3030075187969926 2.982464454976304 17.32050807568877], ...
	'Tag','Axes2Text1', ...
	'Visible','off');
set(get(h2,'Parent'),'ZLabel',h2);
h1 = axes('Parent',h0, ...
	'View',[-37.5 30], ...
	'CameraUpVector',[0 0 1], ...
	'CameraUpVectorMode','manual', ...
	'Color',[1 1 1], ...
	'ColorOrder',mat20, ...
	'Position',[0.1 0.5 0.6 0.35], ...
	'Tag','Axes1', ...
	'XColor',[0 0 0], ...
	'XGrid','on', ...
	'XLim',[-0.1 1.1], ...
	'XLimMode','manual', ...
	'YColor',[0 0 0], ...
	'YGrid','on', ...
	'YLim',[-0.1 1.1], ...
	'YLimMode','manual', ...
	'ZColor',[0 0 0], ...
	'ZGrid','on');
h2 = patch('Parent',h1, ...
	'EdgeColor','none', ...
	'FaceColor','interp', ...
	'Faces',mat21, ...
	'FaceVertexCData',mat22, ...
	'NormalMode','manual', ...
	'Tag','Axes1Patch4', ...
	'VertexNormals',mat23, ...
	'Vertices',mat24);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',mat25, ...
	'String','solution  u(x,y)', ...
	'Tag','Axes1Text4', ...
	'VerticalAlignment','bottom');
set(get(h2,'Parent'),'Title',h2);
h2 = line('Parent',h1, ...
	'Color',[0 0 1], ...
	'Tag','Axes1Line2', ...
	'XData',mat26, ...
	'YData',mat27, ...
	'ZData',mat28);
h2 = patch('Parent',h1, ...
	'FaceColor','flat', ...
	'Faces',1, ...
	'FaceVertexCData',0, ...
	'NormalMode','manual', ...
	'Tag','Axes1Patch3', ...
	'VertexNormals',mat29, ...
	'Vertices',[0 0], ...
	'Visible','off');
h2 = patch('Parent',h1, ...
	'EdgeColor','none', ...
	'FaceColor','interp', ...
	'Faces',mat30, ...
	'FaceVertexCData',mat31, ...
	'NormalMode','manual', ...
	'Tag','Axes1Patch2', ...
	'VertexNormals',mat32, ...
	'Vertices',mat33);
h2 = line('Parent',h1, ...
	'Color',[0 0 1], ...
	'Tag','Axes1Line1', ...
	'XData',mat34, ...
	'YData',mat35, ...
	'ZData',mat36);
h2 = patch('Parent',h1, ...
	'FaceColor','flat', ...
	'Faces',1, ...
	'FaceVertexCData',0, ...
	'NormalMode','manual', ...
	'Tag','Axes1Patch1', ...
	'VertexNormals',mat37, ...
	'Vertices',[0 0], ...
	'Visible','off');
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'Position',[-5.038666555567636 -7.237655307112501 0.07686794804259608], ...
	'Tag','Axes1Text3', ...
	'VerticalAlignment','top');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Position',[-5.672821941775922 -6.734119925057303 0.07725570047248682], ...
	'Tag','Axes1Text2', ...
	'VerticalAlignment','top');
set(get(h2,'Parent'),'YLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[-5.763121802475631 -6.010171271977802 0.09224879442826178], ...
	'Rotation',90, ...
	'Tag','Axes1Text1', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'ZLabel',h2);
if nargout > 0, fig = h0; end
