function INT_adm(action)

global X xx Y yy U select_point scale
     
switch action


case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','INT_adm(''set axis'')')
   scale=.5;
   
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','INT_adm(''set axis'')')
   scale=2;
   
   
case 'refocus'
   set(gcbf,'WindowButtonDownFcn','INT_adm(''set axis'')')
   scale=1;
   
   
case 'set axis'
   hu=findobj(gcbf,'Tag','u-window');
   hf=findobj(gcbf,'Tag','f-window');
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(hu,'XLim',NewXLim,'YLim',NewYLim)
   set(hf,'XLim',NewXLim,'YLim',NewYLim)
   INT_adm('update graphics')
   
   
case 'WBDF'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   t=get(fo('f-window'),'UserData');
   if t=='cv'
      set(gcbf,'WindowButtonMotionFcn','INT_adm(''WBMF-cv'')')
   elseif t=='mb'
      set(gcbf,'WindowButtonMotionFcn','INT_adm(''WBMF-mb'')')
      set(fo('bf-text'),'String','x')
      set(fo('bu-text'),'String','x')
   end
   set(gcbf,'WindowButtonUpFcn','INT_adm(''WBUF'')')

   
case 'WBMF-mb'
   Df=eval(get(fo('Df'),'String'));
   cp=get(gca,'CurrentPoint');
   cp=min(cp(1,1:2),Df(2));
   cp=max(cp,Df(1));
   set(fo('b'),'String',num2str(cp(1)));
   INT_adm('integrate2')
   
   
case 'WBMF-cv'
   delete(fo('f-temp'))
   axes(fo('f-window'))
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   h=findobj(gcbf,'Tag','y=F(x)');
   xx=get(h,'XData');
   yy=get(h,'YData');
   index=length(xx(xx<cp(1)));
   index=min(index,length(yy)-1);
   index=max(1,index);
   yy(index)=cp(2);
   yy(index+1)=cp(2);
   set(h,'YData',yy)
   title('y = F(x)')
   for i=1:2:2*length(Y)
     line([xx(i) xx(i)],[0 yy(i)],'Color',[0 0 0],'LineStyle',':','Tag','f-temp')
   end
   l=length(Y);
   line([xx(l) xx(l)],[0 yy(l)],'Color',[0 0 0],'LineStyle',':','Tag','f-temp')
   INT_adm('sum f(x)dx')
   set(fo('y=f(x)'),'Color',[.9 .9 1])
   axes(fo('u-window'))
   title(['y = U(x),   U(a) = u(a)  &  U(x) = F(x)'])
   
   
case 'WBUF'
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   set(fo('bf-text'),'String','b')
   set(fo('bu-text'),'String','b')

   
case 'b'
   set(fo('f-window'),'UserData','mb')
   Df=eval(get(fo('Df'),'String'));
   b=eval(get(fo('b'),'String'));
   set(fo('b'),'String',num2str(max(min(b,Df(2)),Df(1))))
   INT_adm('integrate')
   
   
case 'u(x)'
   Dg=eval(get(fo('Dg'),'String'));
   XLim=get(fo('u-window'),'XLim');
   if     get(fo('u-type'),'Value')==1
      dx=diff(Dg)/50;
   elseif get(fo('u-type'),'Value')==2
      dx=min(diff(Dg),diff(XLim))/1000;
   end
   x=max(Dg(1),XLim(1)):dx:min(Dg(2),XLim(2));
   u=eval(get(fo('u(x)'),'String'));
   set(fo('y=u(x)'),'XData',x,'YData',u,'Visible','on','Color',[1 0 1])
   
   
case 'Du(x)'
   set(gcbf,'UserData','u2f')
   INT_adm('update graphics')
      
   
case 'update graphics'
   direction=get(gcf,'UserData');
   
   if direction=='u2f'
     INT_adm('u(x)')
     delete(fo('u-temp'))
     delete(fo('f-temp'))
     Dg=eval(get(fo('Dg'),'String'));
     XLim=get(fo('f-window'),'XLim');
     if     get(fo('u-type'),'Value')==1
        dx=diff(Dg)/50;
     elseif get(fo('u-type'),'Value')==2
        dx=min(diff(Dg),diff(XLim))/1000;
     end
     x=max(Dg(1),XLim(1)):dx:min(Dg(2),XLim(2));
     ux=get(fo('u(x)'),'String');
     u=eval(ux);
   
     l=length(x)-1;
     XX=[];
     XX(1:2:2*l-1)=x(1:l);
     XX(2:2:2*l)=x(2:l+1);
     du=diff(u);
     Du(1:2:2*l-1)=du./diff(x);
     Du(2:2:2*l)=du./diff(x);
     set(fo('y=f(x)'),'XData',XX,'YData',Du,'Color',[1 0 1])
     
     set(fo('y=U(x)'),'Visible','off')
     set(fo('y=F(x)'),'Visible','off')
     set(fo('y=u(x)'),'Visible','on')
     set(fo('y=f(x)'),'Visible','on','Color',[1 0 1])
     axes(fo('u-window'));
     XLim=get(gca,'XLim');
     YLim=get(gca,'YLim');
     set(findobj(gcbf,'Tag','xu-axis'),'XData',XLim)
     set(findobj(gcbf,'Tag','yu-axis'),'YData',YLim)
     title('y = u(x)')
     axes(fo('f-window'));
     XLim=get(gca,'XLim');
     YLim=get(gca,'YLim');
     set(findobj(gcbf,'Tag','xf-axis'),'XData',XLim)
     set(findobj(gcbf,'Tag','yf-axis'),'YData',YLim)
     title('y = Du(x)')
      
     set(fo('au-text'),'Visible','off')
     set(fo('bu-text'),'Visible','off')
     set(fo('au-line'),'Visible','off')
     set(fo('bu-line'),'Visible','off')
     set(fo('af-text'),'Visible','off')
     set(fo('bf-text'),'Visible','off')
     set(fo('af-line'),'Visible','off')
     set(fo('bf-line'),'Visible','off')
      
   elseif direction=='f2u'
     delete(fo('f-temp'))
 %    axes(fo('u-window'))
 %    for i=1:length(X)
 %      line([X(i) X(i)],[0 U(i)],'Color',[0 0 0],'LineStyle',':','Tag','u-temp')
 %    end
     axes(fo('f-window'))
     hold on
     for i=1:length(Y)
       fill([X(i) X(i+1) X(i+1) X(i)],[0 0 Y(i) Y(i)],[.9+.1*max(Y(i)/(abs(Y(i))+eps),0) 0.9 .9+.1*max(-Y(i)/(abs(Y(i))+eps),0)],'Tag','f-temp')
     end
     hold off
 %    set(fo('y=U(x)'),'XData',X,'YData',U,'Visible','on')
 %    set(fo('bu-line'),'YData',[0 U(length(U))])

 %    set(fo('y=U(x)'),'Visible','on')
 %    set(fo('y=F(x)'),'Visible','on')
     set(fo('y=u(x)'),'Visible','off')
 %    set(fo('y=f(x)'),'Color',[1 0 1])
     
     axes(fo('u-window'));
     XLim=get(gca,'XLim');
     YLim=get(gca,'YLim');
     dX=diff(XLim);
     set(findobj(gcbf,'Tag','xu-axis'),'XData',XLim)
     set(findobj(gcbf,'Tag','yu-axis'),'YData',YLim)
     title('y = U(x) \approx u(a) + \int_a^x f(\xi)d\xi')
     
     set(fo('au-text'),'Visible','on','Position',[X(1)-dX/100 -dX/15])
     set(fo('bu-text'),'Visible','on','Position',[X(length(X))-dX/100 -dX/10])
     set(fo('au-line'),'Visible','off')
     set(fo('bu-line'),'Visible','off','XData',X(length(X))*[1 1])
     
     axes(fo('f-window'));
     XLim=get(gca,'XLim');
     YLim=get(gca,'YLim');
     dX=diff(XLim);
     set(findobj(gcbf,'Tag','xf-axis'),'XData',XLim)
     set(findobj(gcbf,'Tag','yf-axis'),'YData',YLim)
     title('y = f(x)  &  y = F(x)')
     
     set(fo('af-text'),'Visible','on','Position',[X(1)-dX/100 -dX/15])
     set(fo('bf-text'),'Visible','on','Position',[X(length(X))-dX/100 -dX/10])
     set(fo('af-line'),'Visible','off')
     set(fo('bf-line'),'Visible','off')
   end
  

case 'update graphics2'
   axes(fo('u-window'))
%   for i=length(X)
%     line([X(i) X(i)],[0 U(i)],'Color',[0 0 0],'LineStyle',':','Tag','u-temp')
%   end
   axes(fo('f-window'))
   hold on
   for i=length(Y)
     fill([X(i) X(i+1) X(i+1) X(i)],[0 0 Y(i) Y(i)],[.9+.1*max(Y(i)/(abs(Y(i))+eps),0) 0.9 .9+.1*max(-Y(i)/(abs(Y(i))+eps),0)],'Tag','f-temp')
   end
   hold off
%   set(fo('y=U(x)'),'XData',X,'YData',U,'Visible','on')
%   set(fo('bu-line'),'YData',[0 U(length(U))])

%   set(fo('y=U(x)'),'Visible','on')
%   set(fo('y=F(x)'),'Visible','on')
   set(fo('y=u(x)'),'Visible','off')
%   set(fo('y=f(x)'),'Color',[1 0 1])
     
   axes(fo('u-window'));
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=diff(XLim);
   set(findobj(gcbf,'Tag','xu-axis'),'XData',XLim)
   set(findobj(gcbf,'Tag','yu-axis'),'YData',YLim)
   title('y = U(x) \approx u(a) + \int_a^x f(\xi)d\xi')
     
   set(fo('au-text'),'Visible','on','Position',[X(1)-dX/100 -dX/15])
   set(fo('bu-text'),'Visible','on','Position',[X(length(X))-dX/100 -dX/10])
   set(fo('au-line'),'Visible','off')
   set(fo('bu-line'),'Visible','off','XData',X(length(X))*[1 1])
     
   axes(fo('f-window'));
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=diff(XLim);
   set(findobj(gcbf,'Tag','xf-axis'),'XData',XLim)
   set(findobj(gcbf,'Tag','yf-axis'),'YData',YLim)
   title('y = f(x)  &  y = F(x)')
     
   set(fo('af-text'),'Visible','on','Position',[X(1)-dX/100 -dX/15])
   set(fo('bf-text'),'Visible','on','Position',[X(length(X))-dX/100 -dX/10])
   set(fo('af-line'),'Visible','off')
   set(fo('bf-line'),'Visible','off')
   
   
case 'interpolate'
   delete(fo('f-temp'))
   INT_adm('f(x)')
   a=eval(get(fo('a'),'String'));
   b=eval(get(fo('b'),'String'));
   ip=get(fo('IP slider'),'Value');
   h=eval(get(fo('h'),'String'));
   H=abs(b-a);
   X=[a:h:a+H];
   X=[X a+H];
   m=(b-a)/(abs(b-a)+eps);
   X=a+m*(X-a);
 
   l=length(X)-1;
   x=X(1:l)+ip*diff(X);
   fh=eval(get(fo('f(x)'),'String')).*ones(size(x));
   Y=fh;
   xx=[];
   xx(1:2:2*l-1)=X(1:l);
   xx(2:2:2*l)=X(2:l+1);
   FH=[];
   FH(1:2:2*l-1)=fh;
   FH(2:2:2*l)=fh;
   yy=FH;
   set(fo('y=F(x)'),'XData',xx,'YData',FH,'Visible','on')
   axes(fo('f-window'))
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   for i=1:l
     line([X(i) X(i)],[0 fh(i)],'Color',[0 0 0],'LineStyle',':','Tag','f-temp')
   end
   l=length(fh);
   line([X(l) X(l)],[0 fh(l)],'Color',[0 0 0],'LineStyle',':','Tag','f-temp')
   set(gca,'XLim',XLim,'YLim',YLim)
   tit=get(get(gca,'title'),'String');
   title([tit '  &  y = F(x)'])
   
   
case 'sum f(x)dx'
   delete(fo('u-temp'))
   
   a=eval(get(fo('a'),'String'));
   ua=eval(get(fo('u(a)'),'String'));
   b=eval(get(fo('b'),'String'));
   
   h=eval(get(fo('h'),'String'));
   ip=get(fo('IP slider'),'Value');
   H=abs(b-a);
   X=[a:h:a+H];
   X=[X a+H];
   m=(b-a)/(abs(b-a)+eps);
   X=a+m*(X-a);
   
   l=length(X)-1;
   x=X(1:l)+ip*diff(X);
   yy=get(fo('y=F(x)'),'YData');
   fh=yy(1:2:length(yy)-1);
   Y=fh;
   
   dx=diff(X);
   uh=ua;
   axes(fo('u-window'))
   for i=1:l
      uh=[uh uh(i)+dx(i)*fh(i)];
      line([X(i) X(i)],[0 uh(i)],'LineStyle',':','Tag','u-temp')
   end
   U=uh;
   set(fo('y=U(x)'),'XData',X,'YData',U,'Visible','on');
   axes(fo('u-window'))
   
   
case 'f(x)'
   Df=eval(get(fo('Df'),'String'));
   XLim=get(fo('f-window'),'XLim');
   dx=min(diff(Df),diff(XLim))/1000;
   x=max(Df(1),XLim(1)):dx:min(Df(2),XLim(2));
   f=eval(get(fo('f(x)'),'String')).*ones(size(x));
   set(fo('y=f(x)'),'XData',x,'YData',f,'Visible','on','Color',[1 0 1])
   set(gcbf,'UserData','f2u')
   axes(fo('f-window'))
   title('y = f(x)')
   
   
case 'h'
   INT_adm('interpolate')
   h=eval(get(fo('h'),'String'));
   set(fo('h slider'),'Value',h)
   
   
case 'integrate'
   if length(X)>20
      INT_adm('integrate2')
      return
   end
   set(gcbf,'UserData','f2u')
   INT_adm('interpolate')
   INT_adm('sum f(x)dx')
   Xcopy=X;
   Ycopy=Y;
   Ucopy=U;
   xxcopy=xx;
   yycopy=yy;
   set(fo('bf-text'),'String','x')
   set(fo('bu-text'),'String','x')
   for i=1:length(Ycopy)
      X=Xcopy(1:i+1);
      Y=Ycopy(1:i);
      U=Ucopy(1:i+1);
      xx=xxcopy(1:2*i);
      yy=yycopy(1:2*i);
      INT_adm('update graphics2')
      drawnow
   end
   set(fo('bf-text'),'String','b')
   set(fo('bu-text'),'String','b')
   
   set(gcbf,'WindowButtonDownFcn','INT_adm(''WBDF'')')
   
   
case 'integrate2'
   set(gcbf,'UserData','f2u')
   INT_adm('interpolate')
   INT_adm('sum f(x)dx')
   INT_adm('update graphics')
   
   set(gcbf,'WindowButtonDownFcn','INT_adm(''WBDF'')')
   
   
case 'slide IP'
   set(fo('f-window'),'UserData','cv')
   INT_adm('interpolate')
   
   
case 'slide h'
   h=get(fo('h slider'),'Value');
   set(fo('h'),'String',num2str(h))
   INT_adm('interpolate')
   

case 'choose_fcn'
   s=get(fo('f gallery'),'String');
   v=get(fo('f gallery'),'Value');
   set(fo('f(x)'),'String',s{v})
   INT_adm('f(x)')

 
end


function o=fo(tag)
o=findobj(gcbf,'Tag',tag);


