function NEWTR_adm(action)

global scale NewXLim NewYLim L_X M_X R_X

switch action

case 'x'
   h=findobj(gcbf,'Tag','x');
   x=get(h,'String');
   x=eval(x);
   h=findobj(gcbf,'Tag','my_fcn');
   f=get(h,'String');
   f=eval(f);
%   set(findobj(gcbf,'Tag','f(x)'),'String',num2str(f))
   NEWTR_adm('residual')

   
case 'update'
   dx=diff(get(gca,'XLim'));
   hx=findobj(gcbf,'Tag','x');
   x=eval(get(hx,'String'));
   hfx=findobj(gcbf,'Tag','f(x)');
   fx=eval(get(hfx,'String'));
   h=findobj(gcbf,'Tag','curr_iteration');
   set(h,'XData',[x x 0],'YData',[0 fx fx])
   hx=findobj(gcbf,'Tag','x-text');
   set(hx,'Position',[x-.05/dx -.1/dx])
   hfx=findobj(gcbf,'Tag','fx-text');
   set(hfx,'Position',[-.4/dx fx])
   hfx2=findobj(gcbf,'Tag','fx2-text');
   set(hfx2,'Visible','off')
   drawnow
   pause(1)
   set(h,'XData',[x x 0 fx fx],'YData',[0 fx fx fx 0])
   hgx2=findobj(gcbf,'Tag','fx2-text');
   set(hfx2,'Position',[fx-.15/dx -.1/dx],'Visible','on')
   drawnow
   pause(1)
%   format long
%  L_X{size(L_X,1)+1,1}=num2str(l_x)
%  M_X{size(M_X,1)+1,1}=num2str((l_x+r_x)/2)
%  R_X{size(R_X,1)+1,1}=num2str(r_x)
%   format short  
   
   
case 'linearize'
   h=findobj(gcbf,'Tag','x');
   xs=get(h,'String');
   h=findobj(gcbf,'Tag','my_fcn');
   fx=get(h,'String');
   dx=0.000001;
   x=eval(xs)-dx/2;
   f=eval(fx);
   x=x+dx;
   Df=(eval(fx)-f)/dx;
   x=x-dx/2;
   f=eval(fx);
   XLim=get(gca,'XLim');
   y=[f+Df*(XLim(1)-x) f+Df*(XLim(2)-x)];
   h=findobj(gcbf,'Tag','y=x');
   set(h,'XData',XLim,'YData',y,'Visible','on','Color',[1 0 0])
   h=findobj(gcbf,'Tag','f_graph');
   set(h,'Color',[1 0.8 0.8])
   title('y = f(a) + Df(a) (x - a)')
   hx=findobj(gcbf,'Tag','x-text');
   pos=get(hx,'Position');
   ha=findobj(gcbf,'Tag','a-text');
   set(ha,'Visible','on','Position',pos)
   set(hx,'Visible','off')
   h=findobj(gcbf,'Tag','fx-text');
   set(h,'String','f(a)')
   
   
case 'solve'
   h=findobj(gcbf,'Tag','x');
   xs=get(h,'String');
   h=findobj(gcbf,'Tag','my_fcn');
   fx=get(h,'String');
   dx=0.000001;
   x=eval(xs)-dx/2;
   f=eval(fx);
   x=x+dx;
   Df=(eval(fx)-f)/dx;
   x=x-dx/2;
   f=eval(fx);
   x=x-f/Df;
   h=findobj(gcbf,'Tag','x');
   set(h,'String',num2str(x))
   dx=diff(get(gca,'XLim'));
   hx=findobj(gcbf,'Tag','x-text');
   set(hx,'Position',[x-.05/dx -.1/dx],'Visible','on')
   h=findobj(gcbf,'Tag','fx-text');
%   set(h,'Visible','off')
   h=findobj(gcbf,'Tag','curr_iteration');
   set(h,'Color',[.8 .8 1])
   %set(h,'Visible','off')
   title('0 = f(a) + Df(a) (x - a)')
   
   
case 'residual'
   
   h=findobj(gcbf,'Tag','x');
   x=eval(get(h,'String'));
   h=findobj(gcbf,'Tag','my_fcn');
   fx=get(h,'String');
   fx=eval(fx);
   h=findobj(gcbf,'Tag','f(x)');
   set(h,'String',num2str(fx))
   h=findobj(gcbf,'Tag','curr_iteration');
   set(h,'XData',[x x 0],'YData',[0 fx fx],'Visible','on','Color',[0 0 1])
   dx=diff(get(gca,'XLim'));
   hx=findobj(gcbf,'Tag','x-text');
   set(hx,'Position',[x-.007*dx -.017*dx])
   hfx=findobj(gcbf,'Tag','fx-text');
   set(hfx,'Position',[-.06*dx fx],'Visible','on','String','f(x)')
   h=findobj(gcbf,'Tag','y=x');
%   set(h,'Visible','off')
   set(h,'Color',[1 .8 .8])
   h=findobj(gcbf,'Tag','f_graph');
   set(h,'Color',[1 0 0])
   ha=findobj(gcbf,'Tag','a-text');
   set(ha,'Visible','off')
   title('y = f(x)')
  
   
   
case 'iterate'
   NEWTR_adm('linearize')
   drawnow
   pause(1)
   NEWTR_adm('solve')
   drawnow
   pause(1)
   NEWTR_adm('residual')
   drawnow
   pause(1)
   
   
case 'nits'
   h=findobj(gcbf,'Tag','nits');
   nits=get(h,'String');
   nits=eval(nits);
   for i=1:nits
     NEWTR_adm('iterate')
   end
   
   
case 'tol'
   h=findobj(gcbf,'Tag','tol');
   tol=get(h,'String');
   tol=eval(tol);
   fx=1;
   hx=findobj(gcbf,'Tag','x');
   hgx=findobj(gcbf,'Tag','f(x)');
   while abs(fx)>tol
      NEWTR_adm('iterate')
      x=eval(get(hx,'String'));
      fx=eval(get(hfx,'String'));
   end
   
   
case 'zoom in'
  
  scale=.5;
  set(gcf,'WindowButtonDownFcn','NEWTR_adm(''zoom'')')


case 'zoom out'
  
  scale=2;
  set(gcf,'WindowButtonDownFcn','NEWTR_adm(''zoom'')')
  
  
case 'zoom'
   
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   NEWTR_adm('plot_fcn')
   
   h=findobj(gcbf,'Tag','x');
   x=eval(get(h,'String'));
   h=findobj(gcbf,'Tag','f(x)');
   fx=eval(get(h,'String'));
   dx=diff(get(gca,'XLim'));
   hx=findobj(gcbf,'Tag','x-text');
   set(hx,'Position',[x-.007*dx -.017*dx])
   hfx=findobj(gcbf,'Tag','fx-text');
   set(hfx,'Position',[-.06*dx fx],'Visible','on')

   
   
case 'choose_fcn'

  value=get(findobj(gcbf,'Tag','f_gallery'),'Value');
  string=get(findobj(gcbf,'Tag','f_gallery'),'String');
  f=string{value};

  set(findobj(gcbf,'Tag','my_fcn'),'String',f)
  NEWTR_adm('plot_fcn')


case 'plot_fcn'

 % delete(findobj(gcbf,'Tag','y=x'))
  delete(findobj(gcbf,'Tag','f_graph'))
  title('')

  f=get(findobj(gcbf,'Tag','my_fcn'),'String');
  if isempty(f)
    disp('no graph to plot')
  else
    f=get(findobj(gcbf,'Tag','my_fcn'),'String');
    XLim=get(gca,'XLim');
    YLim=get(gca,'YLim');
    dX=diff(XLim);
    x=XLim(1):dX/100:XLim(2);
    y=eval(f);
 %   line(x,x,'Color','r','Tag','y=x')
    line(x,eval(f),'Color','r','Tag','f_graph')
    title(['y = ' f])
    axis([x(1) x(length(x)) min(y)-.5 max(y)+.5]);
    set(findobj('Tag','x_axis'),'XData',XLim)
    set(findobj('Tag','y_axis'),'Ydata',YLim)
    NEWTR_adm('linearize')
    set(gca,'XLim',XLim,'YLim',YLim)
  end
   

end




